#ModelSwarm.py
import Tools
from Bug import *
from ActionGroup import *

f=""


class ModelSwarm:
    def __init__(self, nBugs, worldXSize, worldYSize):
        # the environment
        self.nBugs = nBugs
        self.bugList = []

        self.worldXSize= worldXSize
        self.worldYSize= worldYSize

    # objects
    def buildObjects(self):
        for i in range(self.nBugs):
            aBug = Bug(i, random.randint(0,self.worldXSize-1), 
                    random.randint(0,self.worldYSize-1), self.worldXSize,
                    self.worldYSize)
            self.bugList.append(aBug)
        print

    # actions
    def buildActions(self):

        self.actionGroup1 = ActionGroup ("move")
        def do1(address):

            actionDictionary[self.actionGroup1.getName()]=self.actionGroup1

            # keep safe the original list
            address.bugListCopy=address.bugList[:]
            # never in the same order (please comment if you want to keep
            # always the same sequence
            random.shuffle(address.bugListCopy)
            # move with a jump, to have to transfer a parameter
            # the format is: collection, method, parameters by name
            # ask each agent, without parameters
            # the potential jump is the same for all the agents
            askEachAgentIn(address.bugListCopy,Bug.randomWalk,
                                        jump=random.uniform(0,5))

            self.actionGroup1.execLocalCode()

        self.actionGroup1.do = do1 # do is a variable linking a method

        self.actionGroup2 = ActionGroup ("read_schedule")
        def do2(address):

            actionDictionary[self.actionGroup2.getName()]=self.actionGroup2

            try: task=f.readline()
            except: pass
            if task=='':task='0 0'
            task=task.split()

            if task[0]=='Bug':
              # keep safe the original list
              localList=address.bugList[:]
              # never in the same order (please comment if you want to keep
              # always the same sequence
              random.shuffle(localList)
              # apply
              self.applyFromSchedule(localList,task)
                   

        self.actionGroup2.do = do2 # do is a variable linking a method
    
    

        # schedule
        self.actionList = [["move","read_schedule"]]

        # or
        #self.actionList = [["move"],[]]


    # run a step
    def step(self):
            global f

            step=extractAStepAndRotate(self.actionList)

            while len(step)>0:
                subStep=extractASubStep(step)


                if subStep == "move":
                        self.actionGroup1.do(self)
                    # self here is the model env.
                    # not added automatically
                    # being do a variable
                    

                if subStep == "read_schedule":
                        if f=="": f=open("schedule.txt","r")
                        self.actionGroup2.do(self)
                    # self here is the model env.
                    # not added automatically
                    # being do a variable


    # from external schedule
    def applyFromSchedule(self,ll,task):
        #print task
        exec "askEachAgentIn(ll,"+task[0]+"."+task[1]+")" 

    # bug list
    def getBugList(self):
        return self.bugList
